/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.vvc.server.core.globalConfigurations.WelcomeToGlobalConfigurations");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");

dojo.require("com.ibm.team.vvc.shared.web.ui.configurations.AddToGlobalConfigurationForm");

dojo.require("net.jazz.ajax.ui.PlatformUI");
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

dojo.requireLocalization("com.ibm.team.vvc.server.core.globalConfigurations", "WelcomeToGlobalConfigurationsMessages");
	
dojo.declare("com.ibm.team.vvc.server.core.globalConfigurations.WelcomeToGlobalConfigurations", [dijit._Widget, dijit._Templated], {
	
	messages: dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.globalConfigurations", "WelcomeToGlobalConfigurationsMessages"),
	templatePath: dojo.moduleUrl("com.ibm.team.vvc.server.core", "globalConfigurations/templates/WelcomeToGlobalConfigurations.html"),
	widgetsInTemplate: true,
	
	constructor: function(){
		var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
		ActionRegistry.registerAction("welcomeToGlobalConfigurations", function(){});
	},
	
	/**
	 * Show the create global configuration form.
	 * 
	 * @param event 
	 * 			The onClick event.  Propogation will be stopped immediately so clicking does nothign.
	 */
	onCreateGlobalConfiguration: function(event){
		dojo.stopEvent(event);
		var form = new com.ibm.team.vvc.shared.web.ui.configurations.AddToGlobalConfigurationForm({
			createOnly : true
		});
	}
	
});
}());
