<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper
    PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
    "http://mybatis.org/dtd/mybatis-3-mapper.dtd">

<mapper namespace="ChangesetHelperService">

  <select id="getMappingInfo" parameterType="hashmap" resultType="hashmap">
    SELECT DISTINCT creator, created, point
    FROM VVC_Mapping 
    JOIN VVC_System ON VVC_System.id = VVC_Mapping.uri 
    WHERE VVC_Mapping.uri = #{mapping}
  </select>
  
  <select id="getChangeSetInfo" parameterType="hashmap" resultType="hashmap">
    SELECT DISTINCT VVC_ChangeSet.uri as changeset, VVC_ChangeSet.title, VVC_ChangeSet.endPoint 
    FROM VVC_ChangeSet 
    WHERE endPoint = #{point}  
  </select>
  
  <select id="findChangeSets" parameterType="hashmap" resultType="hashmap">
    SELECT DISTINCT VVC_ChangeSet.uri as changeset, VVC_ChangeSet.title, VVC_ChangeSet.endPoint, version, creator, created  
    FROM VVC_ChangeSet
    JOIN VVC_Point EndPoint ON EndPoint.uri = VVC_ChangeSet.endPoint
    JOIN VVC_Point MappingPoint ON MappingPoint.changeSet = EndPoint.changeSet  
    JOIN VVC_Mapping on VVC_Mapping.point = MappingPoint.uri  
    JOIN VVC_System on VVC_System.id = VVC_Mapping.uri
    WHERE VVC_Mapping.concept = #{concept} AND EndPoint.purpose = #{purpose} AND EndPoint.configurationSpace = #{confSpace} AND EndPoint.changeSet IS NOT NULL
  </select>
  
</mapper>
