/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
   
dojo.provide("com.ibm.team.vvc.server.core.ui.internal.changesets.ChangesetsPage");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.PlatformUI");


dojo.require('dojo.i18n');
dojo.require("jazz.ui.Breadcrumbs");
dojo.require("com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsWidgit");

dojo.require("com.ibm.team.vvc.server.core.ui.internal.util.PageUtil");
var PageUtil = com.ibm.team.vvc.server.core.ui.internal.util.PageUtil;

dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
var vvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;

dojo.requireLocalization("com.ibm.team.vvc.server.core.ui.internal.changesets", "ChangesetsPageMessages");

(function ()
{
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	
	dojo.declare("com.ibm.team.vvc.server.core.ui.internal.changesets.ChangesetsPage", [dijit._Widget, dijit._Templated], {
	  
		widgetsInTemplate: true,
		
		templatePath: dojo.moduleUrl('com.ibm.team.vvc.server.core', 'ui/internal/changesets/templates/ChangesetsPage.html'),
	   
		constructor: function() {
			
			this.messages = dojo.i18n.getLocalization("com.ibm.team.vvc.server.core.ui.internal.changesets", "ChangesetsPageMessages");
		},
		
		postCreate: function(){
			var self = this;
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction(vvcConstants.EXPLORE_CHANGESETS, this, "showChangesets");
		},
	   
		showChangesets: function() {
			this._constructBreadcrumbs();
			this._constructChangesetsWidgit();
		},
		
		_constructBreadcrumbs:function()
		{
			if (!this._breadcrumbs)
			{
				var parts = [];
				
				segment = {
					label: this.messages.changesets, 
					href : '#action=jazz.viewPage&id=ChangesetsExplorer'
				};
				parts.push(segment);
				
				this._breadcrumbs = new jazz.ui.Breadcrumbs({segments: parts });
				
				this._breadcrumbs.placeAt(dojo.byId("breadcrumbs"));
			}
		},
		
		
		_constructChangesetsWidgit: function() {
			if (!this._changesetsWidgit)
			{
				this._changesetsWidgit = new com.ibm.team.vvc.shared.web.ui.changesets.ChangesetsWidgit();
				
			    /* append the new grid to the div */
			    this._changesetsDiv.appendChild(this._changesetsWidgit.domNode);
			    this._changesetsWidgit.resizeExplorer();
			    this._changesetsWidgit.initialize();
			}
		},

	    uninitialize: function()
		{
	    	if (this._changesetsWidgit) {
				this._changesetsWidgit.destroyRecursive();
				delete this._changesetsWidgit;
			}
	    	if (this._breadcrumbs) {
				this._breadcrumbs.destroyRecursive();
				delete this._breadcrumbs;
			}
		},
		
	})   
	})();
})();